SystemOrganization addCategory: #ConfigurationOftODE!

Object subclass: #ConfigurationOftODE
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOftODE'!

!ConfigurationOftODE class methodsFor: 'development support' stamp: 'dkh 5/22/2011 12:40'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOftODE class methodsFor: 'private' stamp: 'dkh 5/22/2011 12:40'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOftODE class methodsFor: 'private' stamp: 'dkh 5/22/2011 12:40'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOftODE class methodsFor: 'private' stamp: 'dkh 5/22/2011 12:40'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOftODE class methodsFor: 'metacello tool support' stamp: 'dkh 5/22/2011 12:40'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOftODE class methodsFor: 'loading' stamp: 'dkh 5/22/2011 12:40'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOftODE class methodsFor: 'loading' stamp: 'dkh 5/22/2011 12:40'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOftODE class methodsFor: 'loading' stamp: 'dkh 5/22/2011 12:40'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOftODE class methodsFor: 'accessing' stamp: 'dkh 5/22/2011 12:40'!
project

	^self new project! !

!ConfigurationOftODE class methodsFor: 'development support' stamp: 'dkh 5/22/2011 12:40'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOftODE methodsFor: 'baselines' stamp: 'dkh 05/27/2011 13:34'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://seaside.gemstone.com/ss/Naviode'.
		spec project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #'stable';
					loads: #('Base' 'JQuery-UI');
					repository: 'http://www.squeaksource.com/Seaside30' ].
		spec project: 'JQueryWidgetBox' with: [
				spec
					className: 'ConfigurationOfJQueryWidgetBox';
					versionString: #'bleedingEdge';
					loads: #('JQWidgetBox-UILayout-Core');
					repository: 'http://www.squeaksource.com/JQueryWidgetBox' ].
		spec 
			package: 'tODE-Core';
			package: 'tODE-Seaside' with: [
				spec requires: #('tODE-Core' 'Seaside30' 'JQueryWidgetBox') ];
			package: 'tODE-Views' with: [
				spec requires: #('tODE-Seaside') ].
		spec group: 'default' with: #('tODE-Core' 'tODE-Seaside' 'tODE-Views' ). ].

	spec for: #'pharo' do: [
		spec 
			package: 'tODE-Views' with: [
				spec includes: 'tODE-Pharo-Views'];
			package: 'tODE-Pharo-Views' with: [
				spec includes: 'tODE-Views']. ].

	spec for: #'gemstone' do: [
		spec 
			package: 'tODE-Views' with: [
				spec includes: 'tODE-GemStone-Views'];
			package: 'tODE-GemStone-Views' with: [
				spec includes: 'tODE-Views']. ].
! !

!ConfigurationOftODE methodsFor: 'symbolic versions' stamp: 'dkh 5/22/2011 12:40'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1'.
! !

!ConfigurationOftODE methodsFor: 'accessing' stamp: 'dkh 5/22/2011 12:40'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOftODE methodsFor: 'versions' stamp: 'dkh 5/27/2011 20:10'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '- checkpoint ... fleshing out the inspector
- KISSing
- get selected center tab indx logic straightened out
- add frame link to basic inspector view for an object
- inverse frame lookup to reuse frame state and object state
- eliminate frameIndex
0.1 (dkh.7):
- rearrange inspector pane
0.1 (dkh.8):
- getting started on tODE class browser
- tweak inspector
0.1 (dkh.9):
- tweaks
0.1 (dkh.10):
- TOTabSpec keeps the receiver and frame state itself
- added frame tab for inspecting the tODE subsystem
- added explorer view for class tab ... 
0.1 (dkh.11):
- in class explorer, clicking on class should browse refs, like the instance variables ...
0.1 (dkh.12):
- get started on method browser
0.1 (dkh.13):
- change the default application path...
0.1 (dkh.14):
- basic method viewing is implemented ...
0.1 (dkh.15):
- superclass navigation and method browser
0.1 (dkh.16):
- use accordion for method categories in sidebar
0.1 (dkh.17):
- class hierarchy sidebar
0.1 (dkh.18):
- first cut at sanitization in prep for GemStone port
0.1 (dkh.19):
- starting GemStone port
0.1 (dlh.20):
- continued gemstone port
- start adding workspace
0.1 (dkh.21):
- basic port to GemStone complete
0.1 (dkh.24):
- getting TOWorkspace view working ... todo: doit/inspecit
0.1 (dkh.25):
- worksapce is basically working now (safari and chrome)'.
		spec author: 'dkh'.
		spec timestamp: '5/27/2011 20:10'.
		spec 
			project: 'Seaside30' with: '3.0.5';
			project: 'JQueryWidgetBox' with: '1.9'.
		spec 
			package: 'tODE-Core' with: 'tODE-Core-dkh.13';
			package: 'tODE-Seaside' with: 'tODE-Seaside-dkh.10';
			package: 'tODE-Views' with: 'tODE-Views-dkh.18'. ].

	spec for: #'pharo' do: [
		spec package: 'tODE-Pharo-Views' with: 'tODE-Pharo-Views-dkh.7'. ].

	spec for: #'gemstone' do: [
		spec package: 'tODE-GemStone-Views' with: 'tODE-GemStone-Views-dkh.3'. ].
! !
